stages:
  - 🚧:build:🐳:img

.kaniko:
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  variables:
    JSON_CONFIG: |
      {
        "auths": {
          "$CI_REGISTRY": {
            "username": "$CI_REGISTRY_USER",
            "password": "$CI_REGISTRY_PASSWORD"
          }
        }
      }
  script: |
    echo "${JSON_CONFIG}" > /kaniko/.docker/config.json
    /kaniko/executor \
      --context $CI_PROJECT_DIR/$SUB_DIR \
      --dockerfile $CI_PROJECT_DIR/$SUB_DIR/Dockerfile \
      --cache=true \
      --destination $CI_REGISTRY_IMAGE/$SUB_DIR:$CI_COMMIT_TAG

🐳:build:galago-cli:
  image: !reference [.kaniko, image]
  stage: 🚧:build:🐳:img
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
      changes:
        - galago-cli/**/*
    - if: $CI_MERGE_REQUEST_IID
      changes:
        - galago-cli/**/*
  variables:
    SUB_DIR: "galago-cli"
    JSON_CONFIG: !reference [.kaniko, variables, JSON_CONFIG]
  script:
    - !reference [.kaniko, script]

🐳:build:tinygo:
  image: !reference [.kaniko, image]
  stage: 🚧:build:🐳:img
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
      changes:
        - tinygo/**/*
    - if: $CI_MERGE_REQUEST_IID
      changes:
        - tinygo/**/*
  variables:
    SUB_DIR: "tinygo"
    JSON_CONFIG: !reference [.kaniko, variables, JSON_CONFIG]
  script:
    - !reference [.kaniko, script]
  
